diff --git a/drupal7/sites/all/modules/flag/flag_bookmark/flag_bookmark.install b/drupal7/sites/all/modules/flag/flag_bookmark/flag_bookmark.install
index 284784a7..62646125 100644
--- a/drupal7/sites/all/modules/flag/flag_bookmark/flag_bookmark.install
+++ b/drupal7/sites/all/modules/flag/flag_bookmark/flag_bookmark.install
@@ -13,7 +13,7 @@
  */
 function flag_bookmark_enable() {
   // Load the flag API in case we want to use it when enabling.
-  include_once(drupal_get_path('module', 'flag') . '/flag.module');
+  include_once drupal_get_path('module', 'flag') . '/flag.module';
 
   if (!flag_get_flags()) {
     // Install a demonstration flag only if no flag exists. This is to prevent
@@ -21,24 +21,24 @@ function flag_bookmark_enable() {
     // flag is overwritten or re-created.
     $flag = flag_flag::factory_by_entity_type('node');
     $configuration = array(
-        'name' => 'bookmarks',
-        'global' => 0,
-        'show_in_links' => array(
-          'full' => 1,
-          'teaser' => 1,
-        ),
-        'show_on_form' => 1,
-        // The following UI labels aren't wrapped in t() because they are written
-        // to the DB in English. They are passed to t() later, thus allowing for
-        // multilingual sites.
-        'title' => 'Bookmarks',
-        'flag_short' => 'Bookmark this',
-        'flag_long' => 'Add this post to your bookmarks',
-        'flag_message' => 'This post has been added to your bookmarks',
-        'unflag_short' => 'Unbookmark this',
-        'unflag_long' => 'Remove this post from your bookmarks',
-        'unflag_message' => 'This post has been removed from your bookmarks',
-        'types' => _flag_bookmark_install_get_suggested_node_types(),
+      'name' => 'bookmarks',
+      'global' => 0,
+      'show_in_links' => array(
+        'full' => 1,
+        'teaser' => 1,
+      ),
+      'show_on_form' => 1,
+      // The following UI labels aren't wrapped in t() because they are written
+      // to the DB in English. They are passed to t() later, thus allowing for
+      // multilingual sites.
+      'title' => 'Bookmarks',
+      'flag_short' => 'Bookmark this',
+      'flag_long' => 'Add this post to your bookmarks',
+      'flag_message' => 'This post has been added to your bookmarks',
+      'unflag_short' => 'Unbookmark this',
+      'unflag_long' => 'Remove this post from your bookmarks',
+      'unflag_message' => 'This post has been removed from your bookmarks',
+      'types' => _flag_bookmark_install_get_suggested_node_types(),
     );
     $flag->form_input($configuration);
     $flag->save();
@@ -53,7 +53,8 @@ function flag_bookmark_enable() {
 }
 
 /**
- * Returns some node types to which the demonstration 'bookmarks' flag will apply.
+ * Returns some node types to which the demonstration 'bookmarks' flag will
+ * apply.
  */
 function _flag_bookmark_install_get_suggested_node_types() {
   $preferred = array('article', 'story', 'forum', 'blog');
@@ -64,4 +65,3 @@ function _flag_bookmark_install_get_suggested_node_types() {
   }
   return $existing;
 }
-
diff --git a/drupal7/sites/all/modules/flag/includes/flag.actions.inc b/drupal7/sites/all/modules/flag/includes/flag.actions.inc
index f414431e..c9209718 100644
--- a/drupal7/sites/all/modules/flag/includes/flag.actions.inc
+++ b/drupal7/sites/all/modules/flag/includes/flag.actions.inc
@@ -15,7 +15,7 @@ function flag_trigger_info() {
         'label' => t('Object has been flagged with any flag'),
       ),
       'flag_unflag' => array(
-        'label' => t('Object has been unflagged with any flag')
+        'label' => t('Object has been unflagged with any flag'),
       ),
     ),
   );
diff --git a/drupal7/sites/all/modules/flag/includes/flag.admin.inc b/drupal7/sites/all/modules/flag/includes/flag.admin.inc
index 190ceb77..3ed0e26d 100644
--- a/drupal7/sites/all/modules/flag/includes/flag.admin.inc
+++ b/drupal7/sites/all/modules/flag/includes/flag.admin.inc
@@ -77,10 +77,10 @@ function theme_flag_admin_listing($variables) {
 
   foreach ($flags as $flag) {
     $ops = array(
-      'flags_edit' =>  array('title' => t('edit'), 'href' => $flag->admin_path('edit')),
-      'flags_fields' =>  array('title' => t('manage fields'), 'href' => $flag->admin_path('fields')),
-      'flags_delete' =>  array('title' => t('delete'), 'href' => $flag->admin_path('delete')),
-      'flags_export' =>  array('title' => t('export'), 'href' => $flag->admin_path('export')),
+      'flags_edit' => array('title' => t('edit'), 'href' => $flag->admin_path('edit')),
+      'flags_fields' => array('title' => t('manage fields'), 'href' => $flag->admin_path('fields')),
+      'flags_delete' => array('title' => t('delete'), 'href' => $flag->admin_path('delete')),
+      'flags_export' => array('title' => t('export'), 'href' => $flag->admin_path('export')),
     );
     if (!module_exists('field_ui')) {
       unset($ops['flags_fields']);
@@ -116,7 +116,13 @@ function theme_flag_admin_listing($variables) {
   if (count($flags) > 1) {
     $header[] = t('Weight');
   }
-  $header = array_merge($header, array(t('Flag type'), t('Roles'), t('Entity bundles'), t('Global?'), t('Operations')));
+  $header = array_merge($header, array(
+    t('Flag type'),
+    t('Roles'),
+    t('Entity bundles'),
+    t('Global?'),
+    t('Operations'),
+  ));
   $output .= theme('table', array(
     'header' => $header,
     'rows' => $rows,
@@ -142,7 +148,11 @@ function theme_flag_admin_listing_disabled($variables) {
       $ops = array();
       if (!$flag->is_compatible()) {
         $flag_updates_needed = TRUE;
-        $ops['flags_update'] = array('title' => '<strong>' . t('update code') . '</strong>', 'href' => $flag->admin_path('update'), 'html' => TRUE);
+        $ops['flags_update'] = array(
+          'title' => '<strong>' . t('update code') . '</strong>',
+          'href' => $flag->admin_path('update'),
+          'html' => TRUE,
+        );
       }
       else {
         $ops['flags_enable'] = array('title' => t('enable'), 'href' => $flag->admin_path('edit'));
@@ -163,7 +173,12 @@ function theme_flag_admin_listing_disabled($variables) {
   }
 
   if (!empty($rows)) {
-    $header = array(t('Disabled Flags'), t('Module'), t('Flag type'), t('Operations'));
+    $header = array(
+      t('Disabled Flags'),
+      t('Module'),
+      t('Flag type'),
+      t('Operations'),
+    );
     $output .= theme('table', array('header' => $header, 'rows' => $rows));
   }
 
@@ -379,17 +394,17 @@ function flag_form($form, &$form_state, $flag) {
     '#title' => t('Token replacement'),
     '#type' => 'fieldset',
     '#description' =>
-      '<p>' . t('The above six texts may contain any of the tokens listed below. For example, <em>"Flag link text"</em> could be entered as:') . '</p>' .
-      theme('item_list', array(
-        'items' => array(
-          t('Add &lt;em&gt;[node:title]&lt;/em&gt; to your favorites'),
-          t('Add this [node:type] to your favorites'),
-          t('Vote for this proposal ([node:flag-vote-count] people have already done so)'),
-        ),
-        'attributes' => array('class' => 'token-examples'),
-      )) .
-      '<p>' . t('These tokens will be replaced with the appropriate fields from the node (or user, or comment).') . '</p>' .
-      theme('flag_tokens_browser', array('types' => $flag->get_labels_token_types())),
+    '<p>' . t('The above six texts may contain any of the tokens listed below. For example, <em>"Flag link text"</em> could be entered as:') . '</p>' .
+    theme('item_list', array(
+      'items' => array(
+        t('Add &lt;em&gt;[node:title]&lt;/em&gt; to your favorites'),
+        t('Add this [node:type] to your favorites'),
+        t('Vote for this proposal ([node:flag-vote-count] people have already done so)'),
+      ),
+      'attributes' => array('class' => 'token-examples'),
+    )) .
+    '<p>' . t('These tokens will be replaced with the appropriate fields from the node (or user, or comment).') . '</p>' .
+    theme('flag_tokens_browser', array('types' => $flag->get_labels_token_types())),
     '#collapsible' => TRUE,
     '#collapsed' => TRUE,
   );
diff --git a/drupal7/sites/all/modules/flag/includes/flag.export.inc b/drupal7/sites/all/modules/flag/includes/flag.export.inc
index 539899c3..64f7f465 100644
--- a/drupal7/sites/all/modules/flag/includes/flag.export.inc
+++ b/drupal7/sites/all/modules/flag/includes/flag.export.inc
@@ -15,7 +15,8 @@
  *   in hook_flag_default_flags().
  */
 function flag_export_flags($flags = array(), $module = '', $indent = '') {
-  module_load_include('inc', 'features', 'features.export'); // For features_var_export() (optional).
+  // For features_var_export() (optional).
+  module_load_include('inc', 'features', 'features.export');
   $output = $indent . '$flags = array();' . "\n";
   foreach ($flags as $item) {
     if (is_object($item)) {
@@ -269,7 +270,7 @@ function flag_update_export(&$flag) {
     if (substr($class, 0, 11) == 'FlagUpdate_') {
       // @todo: change this to work with the static class when we drop support
       // for PHP 5.2: see commit d5b517.
-      $update_handler = new $class;
+      $update_handler = new $class();
       // Cast to string, as decimals as array keys seem to be rounded down to
       // ints, WTF PHP?
       $version = (string) $update_handler->old_api_version;
@@ -364,7 +365,8 @@ class FlagUpdate_3 {
     }
 
     // Update show_on_comment and show_on_entity properties to use new view
-    // mode settings. Since the old logic was to show on all view modes, do that.
+    // mode settings. Since the old logic was to show on all view modes, do
+    // that.
     if (!empty($flag->show_on_entity) || !empty($flag->show_on_comment)) {
       if ($entity_info = entity_get_info($flag->entity_type)) {
         foreach ($entity_info['view modes'] as $view_mode => $value) {
diff --git a/drupal7/sites/all/modules/flag/includes/flag.pages.inc b/drupal7/sites/all/modules/flag/includes/flag.pages.inc
index 0bb21ce6..611f4413 100644
--- a/drupal7/sites/all/modules/flag/includes/flag.pages.inc
+++ b/drupal7/sites/all/modules/flag/includes/flag.pages.inc
@@ -93,7 +93,7 @@ function flag_confirm($form, &$form_state, $action, $flag, $entity_id) {
 
   $question = $flag->get_label($action . '_confirmation', $entity_id);
   $path = isset($_GET['destination']) ? $_GET['destination'] : '<front>';
-  $yes = $flag->get_label($action . '_short', $entity_id);
+  $yes = strip_tags($flag->get_label($action . '_short', $entity_id));
 
   if ($action == 'flag') {
     // If the action 'flag', we're potentially about to create a new
@@ -101,11 +101,41 @@ function flag_confirm($form, &$form_state, $action, $flag, $entity_id) {
     $flagging = $flag->new_flagging($entity_id);
     field_attach_form('flagging', $flagging, $form, $form_state);
     $form['#flagging'] = $flagging;
+
+    // Take the same approach as Core entity forms: shove all the entity
+    // properties into the form as values so that entity_form_field_validate()
+    // can build a pseudoentity from $form_values in the validate handler.
+    foreach (array(
+      'flag_name',
+      'entity_type',
+      'entity_id',
+      'uid',
+    ) as $key) {
+      $form[$key] = array(
+        '#type' => 'value',
+        '#value' => isset($flagging->$key) ? $flagging->$key : NULL,
+      );
+    }
   }
 
   return confirm_form($form, $question, $path, '', $yes);
 }
 
+/**
+ * Validate handler for the flag confirm form.
+ *
+ * Validate any Field API fields on the Flagging.
+ *
+ * @see flag_confirm()
+ */
+function flag_confirm_validate($form, &$form_state) {
+  // Only validate the entity fields when we're saving an entity.
+  $action = $form_state['values']['action'];
+  if ($action == 'flag') {
+    entity_form_field_validate('flagging', $form, $form_state);
+  }
+}
+
 /**
  * Submit handler for the flag confirm form.
  *
diff --git a/drupal7/sites/all/modules/flag/includes/flag/flag_entity.inc b/drupal7/sites/all/modules/flag/includes/flag/flag_entity.inc
index 8b7fa5ad..b356472e 100644
--- a/drupal7/sites/all/modules/flag/includes/flag/flag_entity.inc
+++ b/drupal7/sites/all/modules/flag/includes/flag/flag_entity.inc
@@ -2,7 +2,7 @@
 
 /**
  * @file
- *   Contains the flag_entity class.
+ * Contains the flag_entity class.
  */
 
 /**
@@ -58,7 +58,8 @@ class flag_entity extends flag_flag {
     }
     // Select the first display option by default if this is a new flag.
     if (empty($this->fid)) {
-      $first_view_mode = reset(array_keys($entity_view_modes));
+      $first_view_mode_keys = array_keys($entity_view_modes);
+      $first_view_mode = reset($first_view_mode_keys);
       $defaults[$first_view_mode] = $first_view_mode;
     }
 
@@ -159,6 +160,37 @@ class flag_entity extends flag_flag {
     );
   }
 
+  /**
+   * Invoke a Rules event in reaction to a flagging or unflagging.
+   *
+   * @param $action
+   *   Either 'flag' or 'unflag'.
+   * @param $flagging
+   *  The flagging entity that is to be removed.
+   * @param $entity_id
+   *  The entity ID of entity being unflagged.
+   * @param $account
+   *  The account performing the unflagging.
+   */
+  protected function invoke_rules_event($action, $flagging, $entity_id, $account) {
+    switch ($action) {
+      case 'flag':
+        $event_name = 'flag_flagged_' . $this->name;
+        break;
+      case 'unflag':
+        $event_name = 'flag_unflagged_' . $this->name;
+        break;
+    }
+
+    $variables = array(
+      'flag' => $this,
+      'flagged_' . $this->entity_type => $entity_id,
+      'flagging_user' => $account,
+      'flagging' => $flagging,
+    );
+    rules_invoke_event_by_args($event_name, $variables);
+  }
+
   /**
    * Returns the entity id, if it already exists.
    */
